﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9
@EndOfDesignText@
' =======================================================================================
' Description ...: Translator for Form Generator
' Requirement(s).: Basic4Android 9.00
' Author ........: Giovanni Rossati (El Condor)
' Version........: 0.1.1
' Date...........: 14 June 2019
' License........: Free to use without any warranties
' =======================================================================================
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
'	Dim dict As Map  = CreateMap("Name":"Nom","Sex":"Sexe","Man":"Homme","Woman":"Femme","Years":"Années","Months":"Mois","Urgency":"Urgence")
	Dim dict As Map  = CreateMap()
	Dim notTranslate As Map = CreateMap("DEFAULT":"", "RDEFAULT":"", "REQUIRES":"", "H":"", "AFTER":"","WINDOW":"", _
									"GROUND":"","LABEL":"")
	Dim pseudo As Map = CreateMap("CHECK":"", "TITLE":"", "TAB":"", "SECTION":"")

	Dim notInDict As Map = CreateMap()

End Sub
Sub translate(params As String) As String
	Dim language As String = Main.parms.Get("language")
	Dim SQLdb As SQL
	If dict.Size = 0 Then
		SQLdb.Initialize(File.DirInternal, "dictionary.db", False)
		Dim cursor As Cursor = SQLdb.ExecQuery("SELECT Word,Translation FROM Dictionary WHERE Language = '" & language & "'")
		For i = 0 To cursor.RowCount - 1
			cursor.Position = i
			dict.Put(cursor.getstring("Word"),cursor.getstring("Translation"))
		Next
	End If
	Dim fg As fgen
	Dim widgets() As String = Regex.Split(";\s*",params)
	fg.Initialize
	For iw = 0 To widgets.Length - 1
		If fg.Left(widgets(iw),1) = "'" Or widgets(iw) = "" Then Continue	' comment
		Dim field() As String = Regex.Split(",", widgets(iw) & ",,,,,,*")
		field(field.Length-1) = ""		' remove *
		Dim wdgType As String = fg.normType.GetDefault(field(0).ToUpperCase,field(0).ToUpperCase)	' upper case and synonim
		If notTranslate.ContainsKey(wdgType) Then Continue
		If pseudo.ContainsKey (wdgType) Then
			If wdgType = "SECTION" Then
				field(1) = getTrans(field(1))
			Else
				field(2) = getTrans(field(2))
			End If
		Else
			' label translation this translate also CHECK SECTION and TAB
			If field(2) = "" Then field(2) = field(1)
			field(2) = getTrans(field(2))
			Select wdgType
				Case "CKB"			' signal
					field(5) = getTrans(field(5))
				Case "QS","R","CMB","CMT","CMX"
					field(5) = splitKey(fg,field(5))
				Case Else			' text widgets
			End Select
		End If
		widgets(iw) = fg.implode(",",field)
	Next
	Return fg.implode(";",widgets)
End Sub
Sub splitKey(fg As fgen,data As String) As String ' split key value (combos, qualitative sliders AND option buttons)
	Dim dt() As String,k As Int
	dt = Regex.Split("\|", data)
	For j = 0 To dt.Length - 1
		k = dt(j).IndexOf(":")
		Dim translated As String = getTrans(dt(j).SubString(k+1))
		dt(j) = dt(j).Replace(dt(j).SubString(k+1),translated)
	Next
	Return fg.implode("|",dt)
End Sub
Sub getTrans(word As String) As String 
	Dim translated As String = dict.GetDefault(word,"")
	If translated = "" Then
		notInDict.Put(word,"")
	End If
	Return dict.GetDefault(word,word)
End Sub
'Sub updateDB(data As Map)
'	If data.get("fg_button") = "Cancel" Then Return
'	dict.Put(data.Get("engWord"),data.Get("transl"))
'End Sub
'Sub getCurrentActivity As Activity
'	Dim r As Reflector
'	r.Target = r.GetActivityBA
'	Return r.GetField("vg")
'End Sub